// Copyright (c) 2016, Herman Bergwerf. All rights reserved.
// Use of this source code is governed by an AGPL-3.0-style license
// that can be found in the LICENSE file.

// THIS FILE IS AUTO-GENERATED, PLEASE DO NOT MODIFY BY HAND.

part of molview_messages.messages.v0;

/// Notifications
/// =============
/// General notification events.

/// Send an error notification.
class NotifyError extends OmnibusEvent {
  /// omnibusId
  static const id = 'molview_messages.v0.NotifyError';

  /// Unique error identifier (prefix with package name, use snake case)
  final String errorid;

  /// Error message
  final String message;

  /// Debugging information encoded into a string
  final String debuginfo;

  /// Constructor
  NotifyError(this.errorid, this.message, this.debuginfo) : super(id);

  /// Construct from passive data structure.
  factory NotifyError.fromPds(final Map<String, dynamic> pds) {
    String errorid;
    String message;
    String debuginfo;

    // Read errorid.
    if (pds.containsKey('errorid') && pds['errorid'] is String) {
      errorid = pds['errorid'] as String;
    } else {
      throw new ArgumentError.value(
          pds, 'pds', "does not contain a valid field for property 'errorid'");
    }

    // Read message.
    if (pds.containsKey('message') && pds['message'] is String) {
      message = pds['message'] as String;
    } else {
      throw new ArgumentError.value(
          pds, 'pds', "does not contain a valid field for property 'message'");
    }

    // Read debuginfo.
    if (pds.containsKey('debuginfo') && pds['debuginfo'] is String) {
      debuginfo = pds['debuginfo'] as String;
    } else {
      throw new ArgumentError.value(pds, 'pds',
          "does not contain a valid field for property 'debuginfo'");
    }

    return new NotifyError(errorid, message, debuginfo);
  }

  /// Generate passive data structure from message properties.
  Map<String, dynamic> toPds() {
    return {'errorid': errorid, 'message': message, 'debuginfo': debuginfo};
  }
}

/// Message handler for NotifyError
class NotifyErrorHandler extends OmnibusEventHandler {
  /// Callback
  final OmnibusEventCallback<NotifyError> _callback;

  /// Constructor
  NotifyErrorHandler(this._callback, StateData state)
      : super(NotifyError.id, state);

  /// Process incoming message.
  Future<List<Future<Null>>> process(OmnibusEvent data) async {
    NotifyError message =
        data is NotifyError ? data : new NotifyError.fromPds(data.toPds());

    return [_callback(message, state)];
  }
}
